unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, DB, ADODB, StdCtrls, Mask, DBCtrls, ExtCtrls, Grids,
  DBGrids, Buttons, QuickRpt, ToolWin, Handles, QRCtrls,typinfo;

type
  TFormWRC = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ADOConnectionSA: TADOConnection;
    ADOQueryProj: TADOQuery;
    ADOQueryProjproj_no: TWideStringField;
    ADOQueryProjproj_name: TWideStringField;
    ADOQueryProjproj_alias: TWideStringField;
    DBGrid1: TDBGrid;
    DataSourceProj: TDataSource;
    Panel1: TPanel;
    Panel2: TPanel;
    DBNavigator1: TDBNavigator;
    Panel3: TPanel;
    Label1: TLabel;
    DBEdit1: TDBEdit;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    ADOConnection2: TADOConnection;
    ADOQueryproj_dataset: TADOQuery;
    ADOQueryproj_datasetproj_no: TWideStringField;
    ADOQueryproj_datasetdataset_class: TIntegerField;
    DBGrid2: TDBGrid;
    ADOQueryproj_datasetdataset_name: TWideStringField;
    Panel4: TPanel;
    Panel5: TPanel;
    DBNavigator2: TDBNavigator;
    Label4: TLabel;
    DBEdit4: TDBEdit;
    Label5: TLabel;
    DBEdit5: TDBEdit;
    ADOQueryproj_datasetdataset_sql: TMemoField;
    Label6: TLabel;
    DBMemo1: TDBMemo;
    TabSheet3: TTabSheet;
    Panel6: TPanel;
    Panel7: TPanel;
    ScrollBox1: TScrollBox;
    QuickRep1: TQuickRep;
    Panel8: TPanel;
    ToolBar1: TToolBar;
    DataSourceproj_dataset: TDataSource;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton0: TSpeedButton;
    StretchHandle1: TStretchHandle;
    Panel9: TPanel;
    Splitter1: TSplitter;
    ToolBar2: TToolBar;
    SpeedButtonLoad: TSpeedButton;
    SpeedButtonSave: TSpeedButton;
    ADOQueryProjproj_report: TMemoField;
    Label7: TLabel;
    DBMemo2: TDBMemo;
    SpeedButtonClear: TSpeedButton;
    GroupBox1: TGroupBox;
    TreeView1: TTreeView;
    Splitter2: TSplitter;
    GroupBox2: TGroupBox;
    Panel10: TPanel;
    ComboBox1: TComboBox;
    sgProp: TStringGrid;
    ComboColor: TComboBox;
    EditCh: TEdit;
    ListSet: TListBox;
    ComboCursor: TComboBox;
    EditNum: TEdit;
    ComboEnum: TComboBox;
    EditStr: TEdit;
    procedure AddToCombo (const S: String);
    procedure ListEnum (pti: PTypeInfo; sList: TStrings; ShowIndex: Boolean);
    function GetOwnerForm (Comp: TComponent): TComponent;
    function IsBitOn (Value: Integer; Bit: Byte): Boolean;
    function SetToString (Value: Cardinal;
         pti: PTypeInfo): string;
    function GetPropValAsString (Obj: TObject;
         PropInfo: PPropInfo): string;
    procedure OnDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ONDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ObjectMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure onquickrepmousedown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label3Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure ADOQueryproj_datasetBeforePost(DataSet: TDataSet);
    procedure FormCreate(Sender: TObject);
    function ComponentToString(Component: TComponent): string;
    function StringToComponent(Value: string;parent:Tcomponent): TComponent;
    procedure SpeedButtonSaveClick(Sender: TObject);
    procedure SpeedButtonLoadClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButtonClearClick(Sender: TObject);
    procedure StretchHandle1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ComboBox1CloseUp(Sender: TObject);
    procedure TreeView1Click(Sender: TObject);
    procedure sgPropSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);

  private
    { Private declarations }
  public
    { Public declarations }
    idx:integer;
    combo:TComboboX;
  end;

var
  FormWRC: TFormWRC;
  vnull:Olevariant;

implementation

uses ADOConEd;

{$R *.dfm}
procedure TFormWRC.ListEnum (pti: PTypeInfo; sList: TStrings; ShowIndex: Boolean);
var I: Integer;
begin
  with GetTypeData(pti)^ do
    for I := MinValue to MaxValue do
      if ShowIndex then
        sList.Add ('  ' + IntToStr (I) + '. ' +
         GetEnumName (pti, I))
      else
        sList.Add (GetEnumName (pti, I));
end;

function TFormWRC.GetOwnerForm (Comp: TComponent): TComponent;
begin
  while not (Comp is TForm) and
      not (Comp is TDataModule) do
    Comp := Comp.Owner;
  Result := Comp;
end;

function TFormWRC.IsBitOn (Value: Integer; Bit: Byte): Boolean;
begin
  Result := (Value and (1 shl Bit)) <> 0;
end;

function TFormWRC.SetToString (Value: Cardinal;
  pti: PTypeInfo): string;
var
  Res: String;  // result
  BaseType: PTypeInfo;
  I: Integer;
  Found: Boolean;
begin
  Found := False;
  // open the expression
  Res := '[';
  // get the type of the enumeration
  // the set is based onto
  BaseType := GetTypeData(pti).CompType^;
  // for each possible value
  for I := GetTypeData (BaseType).MinValue
      to GetTypeData (BaseType).MaxValue do
    // if the bit I (computed as 1 shl I) is set,
    // then the corresponding element is in the set
    // (the and is a bitwise and, not a boolean operation)
    if IsBitOn (Value, I) then
    begin
      // add the name of the element
      Res := Res + GetEnumName (BaseType, I) + ', ';
      Found := True;
    end;
  if Found then
    // remove the final comma and space (2 chars)
    Res := Copy (Res, 1, Length (Res) - 2);
  // close the expression
  Result := Res + ']';
end;

function TFormWRC.GetPropValAsString (Obj: TObject;
  PropInfo: PPropInfo): string;
var
  Pt: Pointer;
  Word: Cardinal;
begin
  case PropInfo.PropType^.Kind of

    tkUnknown:
      Result := 'Unknown type';

    tkChar:
    begin
      Word := GetOrdProp (Obj, PropInfo);
      if Word > 32 then
        Result := Char (Word)
      else
        Result := '#' + IntToStr (Word);
    end;

    tkWChar:
    begin
      Word := GetOrdProp (Obj, PropInfo);
      if Word > 32 then
        Result := WideChar (Word)
      else
        Result := '#' + IntToStr (Word);
    end;


    tkInteger:
      if PropInfo.PropType^.Name = 'TColor' then
        Result := ColorToString (GetOrdProp (Obj, PropInfo))
      else if PropInfo.PropType^.Name = 'TCursor' then
        Result := CursorToString (GetOrdProp (Obj, PropInfo))
      else
        Result := Format ('%d', [GetOrdProp (Obj, PropInfo)]);

    tkEnumeration:
      Result := GetEnumName (PropInfo.PropType^,
        GetOrdProp (Obj, PropInfo));

    tkFloat:
      Result := FloatToStr (GetFloatProp (Obj, PropInfo));

    tkString, tkLString:
      Result := GetStrProp (Obj, PropInfo);

    tkSet:
      Result := SetToString (GetOrdProp (Obj, PropInfo),
        PropInfo.PropType^);

    tkClass:
    begin
      Pt := Pointer (GetOrdProp (Obj, PropInfo));
      if Pt = nil then
        Result := '(None)'
      else
        Result := Format ('(Object %p)', [Pt]);
    end;

    tkMethod:
    begin
      Pt := GetMethodProp (Obj, PropInfo).Code;
      if Pt <> nil then
        Result := GetOwnerForm (Obj as TComponent).
          MethodName (Pt)
      else
        Result := '';
    end;

    tkVariant:
      Result := GetVariantProp (Obj, PropInfo);

    tkArray, tkRecord, tkInterface:
      Result := 'Unsupported type';

    else
      Result := 'Undefined type';
  end;
end;

procedure TFormWRC.ObjectMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var PropInfo: PPropInfo;
    PropList, SubPropList: TPropList;
    NumberOfProps, NumberOfSubProps, // total number of properties
    nProp, nSubProp, // property loop counter
    nRowProp, nRowEvt: Integer; // items actually added
    SubObj: TPersistent;
begin
  if (GetKeyState(VK_SHIFT) >= 0) then
  begin
      StretchHandle1.Detach;
      StretchHandle1.Locked := False;
  end;
  if (idx=0) or not ((Sender is TQRBand) or (Sender is TQRSubdetail) or
     (Sender is TQRGroup) or (Sender is TQRSTringsBand) ) then
  begin
     Combobox1.Text:=TControl(sender).Name;
     StretchHandle1.Attach(TButton(sender));
     sgProp.Cells [1, 0] := '';
   // get the number of properties
     NumberOfProps := GetTypeData(Sender.ClassInfo).PropCount;
  // exaggerate in size...
     sgProp.RowCount := NumberOfProps;
  // get the list of properties and sort it
     GetPropInfos (Sender.ClassInfo, @PropList);
     SortPropList(@PropList, NumberOfProps);
// show the name of each property
// adding it to the proper page
     nRowProp := 0;
     nRowEvt := 0;
     for nProp := 0 to NumberOfProps - 1 do
     begin
// if it is a real property
        if PropList[nProp].PropType^.Kind <> tkMethod then
        begin
// name
           sgProp.Cells [0, nRowProp] := PropList[nProp].Name;
// value
           sgProp.Cells [1, nRowProp] := GetPropValAsString (
                sender, PropList [nProp]);
// data
           sgProp.Objects [0, nRowProp] := TObject (PropList[nProp]);
           sgProp.Objects [1, nRowProp] := nil;
// move to the next line
           Inc (nRowProp);
// if the property is a class
           if (PropList[nProp].PropType^.Kind = tkClass) then
           begin
              SubObj := TPersistent (GetOrdProp (
                  sender, PropList[nProp]));
              if (SubObj <> nil) and not (SubObj is TComponent) then
              begin
                 NumberOfSubProps := GetTypeData(SubObj.ClassInfo).PropCount;
                 if NumberOfSubProps > 0 then
                 begin
// add plus sign
                    sgProp.Cells [0, nRowProp - 1] := '+' +
                    sgProp.Cells [0, nRowProp - 1];
// add space for subproperties...
                    sgProp.RowCount := sgProp.RowCount + NumberOfSubProps;
// get the list of subproperties and sort it
                    GetPropInfos (subObj.ClassInfo, @SubPropList);
                    SortPropList(@SubPropList, NumberOfSubProps);
// show the name of each subproperty
                    for nSubProp := 0 to NumberOfSubProps - 1 do
                    begin
// if it is a real property
                       if SubPropList[nSubProp].PropType^.Kind <> tkMethod then
                       begin
// name (indented)
                          sgProp.Cells [0, nRowProp] :=
                              '    ' + SubPropList[nSubProp].Name;
// value
                          sgProp.Cells [1, nRowProp] := GetPropValAsString (
                             SubObj, SubPropList [nSubProp]);
// data
                          sgProp.Objects [0, nRowProp] :=
                             TObject (SubPropList[nSubProp]);
                          sgProp.Objects [1, nRowProp] := SubObj;
                          Inc (nRowProp);
                       end; // if
                    end; // for
                 end;
              end;
           end; // adding subproperties
        end;
     end;
  end else
     onquickrepmousedown(Sender,Button,Shift, X, Y);

end;
procedure TFormWRC.ONDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
   accept:=true;
end;

procedure TFormWRC.OnDragDrop(Sender, Source: TObject; X, Y: Integer);
var i,j:integer;
    s,s1:string;
    obj:Tobject;
    button:TMouseButton;
    Shift:TShiftstate;
begin
   s1:='QRBand';
   with TWincontrol(Quickrep1) do
   begin
      j:=0;
      i:=0;
      while (i<componentcount) do
      begin
         j:=j+1;
         s:=uppercase(s1+inttostr(j));
         for i:=0 to ComponentCount-1 do
         begin
            if (uppercase(TControl(Components[i]).Name)=s) then
               break;
         end;
      end;
   end;
   obj:=TQRLabel.Create(TComponent(Quickrep1));
   With Tbutton(obj) do
   begin
      name:=s;
      parent:=TWinControl(Sender);
      Left:=x;
      Top:=y;
//            Height:=24;
//            Width:=20;
      OnMouseDown:=ObjectMouseDown;
   end;
   s:=TTreeview(Source).Selected.Text;
   i:=pos(':',s);
   TQRLabel(obj).Caption:= copy(s,i+1,length(s)-i);
   button:=mbLeft;
   ObjectMouseDown(obj,button,Shift,0,0);
//   TTreeview(Source).Selected.Item[0].Text;
end;

function TFormWRC.ComponentToString(Component: TComponent): string;
var
  BinStream:TMemoryStream;
  StrStream: TStringStream;
  s: string;
begin
  BinStream := TMemoryStream.Create;
  try
    StrStream := TStringStream.Create(s);
    try
      BinStream.WriteComponent(Component);
      BinStream.Seek(0, soFromBeginning);
      ObjectBinaryToText(BinStream, StrStream);
      StrStream.Seek(0, soFromBeginning);
      Result:= StrStream.DataString;
    finally
      StrStream.Free;

    end;
  finally
    BinStream.Free
  end;
end;

function TFormWRC.StringToComponent(Value: string;parent:Tcomponent): TComponent;
var
  StrStream:TStringStream;
  BinStream: TMemoryStream;
begin
  StrStream := TStringStream.Create(Value);
  try
    BinStream := TMemoryStream.Create;
    try
      ObjectTextToBinary(StrStream, BinStream);
      BinStream.Seek(0, soFromBeginning);
      Result := BinStream.ReadComponent(parent);

    finally
      BinStream.Free;
    end;
  finally
    StrStream.Free;
  end;
end;

procedure TFormWRC.Label3Click(Sender: TObject);
var ADOConn:TADOConnection;
begin
   ADOConn:=TADOConnection.Create(self);
   ADOConn.Connected:=false;
   ADOConn.LoginPrompt:=false;
   ADOConn.ConnectionString:=ADOQueryProj.fieldbyname('proj_alias').AsString;
   if EditConnectionString(ADOConn) then
   begin
      if not(ADOQueryProj.State in [dsedit,dsinsert]) then
         ADOQueryProj.Edit;
      ADOQueryProj.fieldbyname('proj_alias').AsString:=ADOConn.ConnectionString;
   end;
   ADOConn.Free;
end;

procedure TFormWRC.PageControl1Change(Sender: TObject);
var ADOconn:TADOconnection;
begin
   case PageControl1.ActivePageIndex of
      0:begin
        end;
      1:begin
           if (ADOQueryProj.State in [dsedit,dsinsert]) then
              ADOQueryProj.post;
           try
              ADOConn:=TADOConnection.Create(self);
              ADOConn.LoginPrompt:=false;
              ADOConn.Connected:=false;
              ADOConn.ConnectionString:=ADOQueryProj.fieldbyname('proj_alias').AsString;
              try
                 ADOConn.Connected:=true;
              except
                 showmessage('Ʈw|~');
                 PageControl1.ActivePageIndex:=0;
              end;
           finally
              ADOConn.Free;
           end;
        end;
      2:begin
           if (ADOQueryproj_dataset.State in [dsedit,dsinsert]) then
              ADOQueryproj_dataset.post;
           try
              ADOConn:=TADOConnection.Create(self);
              ADOConn.LoginPrompt:=false;
              ADOConn.Connected:=false;
              ADOConn.ConnectionString:=ADOQueryProj.fieldbyname('proj_alias').AsString;
              try
                 ADOConn.Connected:=true;
              except
                 showmessage('Ʈw|~');
                 PageControl1.ActivePageIndex:=0;
              end;
           finally
              ADOConn.Free;
           end;
           if PageControl1.ActivePageIndex=0 then
              Exit;
           if ((TreeView1.Items.Count=0) and (Quickrep1.ComponentCount=0)) then
              SpeedButtonLoadClick(nil);
        end;
   end;
end;

procedure TFormWRC.ADOQueryproj_datasetBeforePost(DataSet: TDataSet);
begin
   ADOQueryproj_dataset.FieldByName('proj_no').AsString:=ADOQueryProj.fieldbyname('proj_no').AsString;
end;

procedure TFormWRC.onquickrepmousedown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var i,j:integer;
    s,s1:string;
    obj:Tobject;
    ab:boolean;
    Abutton:TMouseButton;
    AShift:TShiftstate;
begin
   if idx>0 then
   begin
      case idx of
         1:S1:='QRsubdetail';
         2:s1:='QRStringsBand';
         3:s1:='QRBand';
         4:s1:='QRGroup';
         5:s1:='QRLabel';
         6:s1:='QRDBText';
         7:s1:='QRExpr';
         8:s1:='QRSysData';
         9:s1:='QRMemo';
         10:s1:='QRRichText';
         11:s1:='QRDBrichtext';
         12:s1:='QRSHAPE';
         13:s1:='QRIMAGE';
         14:s1:='QRDBImage';
      end;
      with TWincontrol(Quickrep1) do
      begin
         i:=0;
         j:=1;
         while (i<componentcount) do
         begin
            s:=uppercase(s1+inttostr(j));
            for i:=0 to ComponentCount-1 do
            begin
               if (uppercase(TControl(Components[i]).Name)=s) then
                 break;
            end;
            if (i<componentcount) then
               j:=j+1;
         end;
         s:=uppercase(s1+inttostr(j));
      end;
      case idx of
         1:obj:=TQRsubdetail.Create(TComponent(Quickrep1));
         2:obj:=TQRStringsBand.Create(TComponent(Quickrep1));
         3:obj:=TQRBand.Create(TComponent(Quickrep1));
         4:obj:=TQRGroup.Create(TComponent(Quickrep1));
         5:obj:=TQRLabel.Create(TComponent(Quickrep1));
         6:obj:=TQRDBText.Create(TComponent(Quickrep1));
         7:obj:=TQRExpr.Create(TComponent(Quickrep1));
         8:obj:=TQRSysData.Create(TComponent(Quickrep1));
         9:obj:=TQRMemo.Create(TComponent(Quickrep1));
         10:obj:=TQRRichText.Create(TComponent(Quickrep1));
         11:obj:=TQRDBrichtext.Create(TComponent(Quickrep1));
         12:obj:=TQRSHAPE.Create(TComponent(Quickrep1));
         13:obj:=TQRIMAGE.Create(TComponent(Quickrep1));
         14:obj:=TQRDBImage.Create(TComponent(Quickrep1));
      end;
      Combobox1.Items.Add(s);
      With Tbutton(obj) do
      begin
         name:=s;
         if idx in [1,2,3,4] then
         begin
            parent:=Quickrep1;
            Height:=24;
            TButton(Sender).OnDragOver:=onDragover;
            TButton(Sender).OnDragDrop:=OnDragDrop;
         end else
         begin
            parent:=TWinControl(Sender);
            Left:=x;
            Top:=y;
//            Height:=24;
//            Width:=20;
         end;
         OnMouseDown:=ObjectMouseDown;
      end;
      SpeedButton0.Down:=True;
      idx:=0;
      Abutton:=mbLeft;
      ObjectMouseDown(obj,Abutton,AShift,0,0);
   end else
   begin
      StretchHandle1.Detach;
      StretchHandle1.Locked := False;
   end;
end;

procedure TFormWRC.AddToCombo (const S: String);
begin
  Combo.Items.Add (S);
end;

procedure TFormWRC.FormCreate(Sender: TObject);
begin
   RegisterClasses([TQRsubdetail,TQRStringsBand,TQRBand,TQRGroup,TQRLabel,
         TQRDBText,TQRExpr,TQRSysData,TQRMemo,TQRRichText,
         TQRDBrichtext,TQRSHAPE,TQRIMAGE,TQRDBImage,TADOQuery,TADOConnection]);
   TButton(Quickrep1).OnMouseDown:=onquickrepmousedown;
   TButton(Quickrep1).OnDragOver:=onDragover;
   TButton(Quickrep1).OnDragDrop:=OnDragDrop;
   PageControl1.ActivePageIndex:=0;
   Combo := ComboCursor;
   GetCursorValues (AddToCombo);
   Combo := ComboColor;
   GetColorValues (AddToCombo);
end;

procedure TFormWRC.SpeedButtonSaveClick(Sender: TObject);
begin
   if not (ADOQueryProj.State in [dsedit,dsinsert]) then
      ADOQueryProj.Edit;
   ADOQueryProj.FieldByName('proj_report').AsString:=ComponentToString(Quickrep1);
   ADOQueryProj.Post;
end;

procedure TFormWRC.SpeedButtonLoadClick(Sender: TObject);
var ADOQ:TADOQuery;
    ADOConn:TADOConnection;
    MyTreeNode1,MyTreeNode2:TTreeNode;
    i,j:integer;
begin
   SpeedButton0.Down:=True;
   idx:=0;
   with Quickrep1 do
   begin
      while (ComponentCount>0) do
      begin
         Components[0].Free;
      end;
   end;
   Combobox1.Clear;
   StringToComponent(ADOQueryProj.FieldByName('proj_report').AsString,Quickrep1);
   with Quickrep1 do
   begin
      i:=0;
      while (i<ComponentCount) do
      begin
         if (Components[i] is TADOQuery) or (Components[i] is TADOConnection) then
            Components[i].Free
         else
         begin
            if ((Components[i] is TQRBand) or (Components[i] is TQRSubdetail) or
                (Components[i] is TQRGroup) or (Components[i] is TQRSTringsBand)) then
            begin
               TButton(Components[i]).OnDragOver:=onDragover;
               TButton(Components[i]).OnDragDrop:=OnDragDrop;
            end;
            TButton(Components[i]).OnMouseDown:=ObjectMouseDown;
            ComboBox1.Items.Add(Components[i].Name);
            i:=i+1;
         end;
      end;
   end;
//   if ((TreeView1.Items.Count=0)and (Quickrep1.ComponentCount=0)) or (MessageDlg('wgƦsb,O_s',mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
//           begin

   ADOConn:=TADOConnection.Create(Quickrep1);
   ADOConn.LoginPrompt:=false;
   ADOconn.Name:='ADOConnection1';
   ADOConn.Connected:=false;
   ADOConn.ConnectionString:=ADOQueryProj.fieldbyname('proj_alias').AsString;
//              ADOConn.Connected:=True;
   TreeView1.DragMode:=dmManual;
   TreeView1.Items.Clear;
   ADOQueryproj_dataset.First;
   while not ADOQueryproj_dataset.Eof do
   begin
      ADOQ:=TADOQuery.Create(Quickrep1);
      ADOQ.Connection:=ADOConn;
      ADOQ.Name:='ADOQuery'+ADOQueryproj_dataset.fieldbyname('dataset_name').AsString;
      if ADOQueryproj_dataset.fieldbyname('dataset_class').AsInteger=1 then
         Quickrep1.DataSet:=ADOQ;
      ADOQ.Active:=false;
      ADOQ.SQL.Text:=ADOQueryproj_dataset.fieldbyname('dataset_sql').AsString;
      ADOQ.Active:=True;
      MyTreeNode1 := TreeView1.Items.Add(nil,ADOQueryproj_dataset.fieldbyname('dataset_name').AsString);
      for i:=0 to ADOQ.FieldCount-1 do
      begin
         MyTreeNode2:=TreeView1.Items.AddChild(MyTreeNode1,ADOQ.Fields[i].FieldName);
         TreeView1.Items.AddChild(MyTreeNode2,'FieldName:'+ADOQ.Fields[i].FieldName);
         TreeView1.Items.AddChild(MyTreeNode2,'DisplayName:'+ADOQ.Fields[i].displayname);
         TreeView1.Items.AddChild(MyTreeNode2,'Size:'+inttostr(ADOQ.Fields[i].Size));
      end;
      ADOQ.Active:=false;
      ADOQueryproj_dataset.Next;
   end;
   ADOConn.LoginPrompt:=false;
end;

procedure TFormWRC.SpeedButton1Click(Sender: TObject);
begin
   if TSpeedButton(sender).Down then
      idx:=TSpeedButton(sender).Tag
   else
   begin
      SpeedButton0.Down:=True;
      idx:=0;
   end;
   StretchHandle1.Detach;
   StretchHandle1.Locked := False;
end;

procedure TFormWRC.SpeedButtonClearClick(Sender: TObject);
var i:integer;
begin
   with Quickrep1 do
   begin
      i:=0;
      while (ComponentCount>i) do
      begin
         if not ((Components[i] is TADOQuery) or (Components[i] is TADOConnection)) then
            Components[i].Free
         else
            i:=i+1;   
      end;
   end;
end;

procedure TFormWRC.StretchHandle1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var i,j:integer;
    obj:TwinControl;
begin
   if key=vk_delete then
   begin
      for i:=0 to StretchHandle1.ChildCount-1 do
      begin
         obj:=TwinControl(StretchHandle1.Children[i]);
         for j:=0 to obj.ControlCount-1 do
            obj.Controls[j].Free;
         Combobox1.Items.Delete(Combobox1.Items.IndexOf(Combobox1.Text));
         Combobox1.Text:='';
         StretchHandle1.Children[i].Free;
      end;
      StretchHandle1.Detach;
   end;
end;

procedure TFormWRC.ComboBox1CloseUp(Sender: TObject);
var obj:Tobject;
    button:TMouseButton;
    Shift:TShiftstate;
begin
   button:=mbLeft;
   obj:=Tobject(Quickrep1.FindComponent(ComboBox1.Items[ComboBox1.ItemIndex]));
   if not (obj=nil) then
      ObjectMouseDown(obj,button,Shift,0,0);
end;

procedure TFormWRC.TreeView1Click(Sender: TObject);
begin
   if TreeView1.Selected.Level=2 then
      TreeView1.DragMode:=dmAutomatic
   else
      TreeView1.DragMode:=dmManual;
end;

procedure TFormWRC.sgPropSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
var
  sg: TStringGrid;
  ppInfo: PPropInfo;
  I: Integer;
  procedure PlaceControl (Ctrl: TWinControl);
  begin
     Ctrl.BringToFront;
     Ctrl.Show;
     Ctrl.BoundsRect := sg.CellRect (ACol, ARow+2);
     Ctrl.Left:=Ctrl.Left+2;
     Ctrl.Width:=Ctrl.Width+2;
     Ctrl.SetFocus;
  end;
begin
   sg := Sender as TStringGrid;
   ppInfo := PPropInfo (sg.Objects [0, ARow] );
   if (ppInfo = nil) then
      Exit;
   case ppInfo.PropType^.Kind of
      tkInteger:begin
         if ppInfo.PropType^.Name = 'TCursor' then
         begin
            ComboCursor.Text := GetPropValAsString (TComponent (sg.Objects [1, ARow]), ppInfo);
            PlaceControl (ComboCursor);
         end else
         begin
            if ppInfo.PropType^.Name = 'TColor' then
            begin
               ComboColor.Tag := GetOrdProp (TComponent (sg.Objects [1, ARow]), ppInfo);
               ComboColor.Text:= GetPropValAsString (TComponent (sg.Objects [1, ARow]), ppInfo);
               PlaceControl (ComboColor)
            end else
            begin
               EditNum.Text := GetPropValAsString (TComponent (sg.Objects [1, ARow]), ppInfo);
               PlaceControl (EditNum);
//               EditModified := False;
            end;
         end;
      end;
      tkChar:begin
         EditCh.Text := GetPropValAsString (TComponent (sg.Objects [1, ARow]), ppInfo);
         PlaceControl (EditCh);
//         EditModified := False;
      end;
      tkEnumeration:
      begin
         ComboEnum.Clear;
         ListEnum (ppInfo.PropType^, ComboEnum.Items, False);
         ComboEnum.ItemIndex := ComboEnum.Items.IndexOf(
            GetPropValAsString(TComponent (sg.Objects [1, ARow]), ppInfo));
         PlaceControl (ComboEnum);
      end;
      tkString, tkLString:begin
         EditStr.Text := GetPropValAsString (
           TComponent (sg.Objects [1, ARow]), ppInfo);
         PlaceControl (EditStr);
//         EditModified := False;
      end;
      tkSet:
      begin
{
         ListSet.Clear;
         ListEnum (
            GetTypeData (ppInfo.PropType^).CompType^,
            ListSet.Items, False);
         // select the "on" items
         for I := 0 to ListSet.Items.Count - 1 do
            ListSet.Selected [I] :=IsBitOn(GetOrdProp (CurrComp, ppINfo), I);
         PlaceControl (ListSet);
         ListSet.Height := ListSet.Height * 8;
}
      end;
      // tkClass: //// see double click...
    end;
end;

end.
